#ifndef __NOKIA_IMPL_H
#define	__NOKIA_IMPL_H

/*
 * These definitions are specific to our *implementation* of the
 * Nokia SDSL/ATM flavor.
 */

/*
 * Rx frame delineation state machine
 * Originally modeled after I.432.1 with frames replacing cells,
 * but then simplified to adapt to SCC limitations.
 * (The rehunt operation in the previous richer FSM caused Tx underrun.)
 */
#define	NOKIARX_STATE_HUNT	0
#define	NOKIARX_STATE_SYNC	2
#define	NOKIARX_STATE_LOSW	3
#define	NOKIARX_STATE_OVERRUN	4

/* Queueable buffers with prepared Tx frames */
struct nokia_preptxf_buf {
	struct	nokia_preptxf_buf *txfb_next;
	struct	nokia_frame_scc frame;
};

#endif	/* __NOKIA_IMPL_H */
